<template>
  <div id="sth">
    <GoogleMaps :markers="favouritesShops"/>
    <ShopListPage :shop-list="favouritesShops" :use-default-data="false"/>
  </div>
</template>

<script>
import ShopListPage from 'pages/ShopListPage'
import GoogleMaps from 'components/GoogleMaps'
import { favouritesShopsRepository } from 'src/public/FavouritesShopRepository'

export default {
  name: 'FavouritesShopsPage',
  components: { GoogleMaps, ShopListPage },
  data: () => {
    return {
      favouritesShops: [],
      notified: new Set()
    }
  },
  methods: {

    calculateDistanceInMeters (x, y) {
      const R = 6371e3 // metres
      const fi1 = x.lat * Math.PI / 180 // φ, λ in radians
      const fi2 = y.lat * Math.PI / 180
      const delta1 = (y.lat - x.lat) * Math.PI / 180
      const delta2 = (y.lng - x.lng) * Math.PI / 180

      const a = Math.sin(delta1 / 2) * Math.sin(delta1 / 2) +
        Math.cos(fi1) * Math.cos(fi2) *
        Math.sin(delta2 / 2) * Math.sin(delta2 / 2)
      const c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1 - a))

      return R * c
    },
    async notificationWhenCloseToTheShop () {
      const currentCoordinates = await this.$getLocation({})
      const shopsNearby = new Set(this.favouritesShops.filter(shop => this.calculateDistanceInMeters(shop.position, currentCoordinates) < shop.radius))
      const shopsToBeHelloNotified = this.setDifference(shopsNearby, this.notified)
      const shopsToBeGoodByeNotified = this.setDifference(this.notified, shopsNearby)
      await this.sendHelloNotification(shopsToBeHelloNotified.values())
      await this.sendGoodByeNotification(shopsToBeGoodByeNotified.values())
      for (const shop of shopsToBeHelloNotified.values()) this.notified.add(shop)
      for (const shop of shopsToBeGoodByeNotified.values()) this.notified.delete(shop)
    },
    async sendHelloNotification (shops) {
      for (const shop of shops) {
        this.$q.notify({
          type: 'positive',
          position: 'top',
          message: `Good to have you nearby. Greetings from ${shop.title} team`
        })
      }
    },
    sendGoodByeNotification (shops) {
      for (const shop of shops) {
        this.$q.notify({
          type: 'info',
          position: 'top',
          message: `It was good to see you. Greetings from ${shop.title} team`
        })
      }
    },
    setDifference (setA, setB) {
      const difference = new Set(setA)
      for (const elem of setB) {
        difference.delete(elem)
      }
      return difference
    }
  },
  async mounted () {
    this.favouritesShops = await favouritesShopsRepository.getAll()
    setInterval(this.notificationWhenCloseToTheShop, 1000)
  }
}
</script>
<style>
  #sth {
   max-height: 762px;
  }
</style>
